<!-- strep.cfm by jeff@grokfusebox.com -->
<!---
<fusedoc fuse="StrEP.cfm" language="ColdFusion" specification="2.0">
  <responsibilities>
    strep = string extraction processor
    I recurse the directory tree starting at the specified "rootDir".  Within 
    each directory, I read the files and look for the specified targetString. 
    I then report each hit, its filename and its line number.
  </responsibilities>
  <history author="jeff@grokfusebox.com" date="07 Feb 02" comments="Version 0.10" />
  <io>
    <in>
      <string name="rootDir" optional="Yes" comments="directory from which to start process" />
      <string name="targetString" optional="No" comments="string to look for" />
    </in>
  </io>
</fusedoc>
--->
<body style="font-family:Verdana,sans-serif;font-size:10pt">

<cfparam name="attributes.rootDir" default="#GetDirectoryFromPath(GetCurrentTemplatePath())#">
<cfparam name="attributes.recurse" default="No">

<cfif attributes.recurse EQ "No">
<hr>
<b>strep v 0.10 by jeff@grokfusebox.com - rundate: <cfoutput>#Dateformat(Now())#, #TimeFormat(Now())#</cfoutput></b>
<hr>
</cfif>

<cfif not isDefined("attributes.targetString")>
  <cfthrow type="strep" errorcode="strep01" message="targetString not specified.">
</cfif>

<cfset Crlf = "#Chr(10)#">

<!--- Trim trailing slash from directory. --->
<cfif Right(attributes.rootDir,1) EQ "\">
  <cfset attributes.rootDir = Left(attributes.rootDir,Len(attributes.rootDir)-1)>
</cfif>

<!---   Read directory entries into array --->
<cfoutput>
<b>Reading directory #attributes.rootDir#.</b><br>
</cfoutput>
<cfdirectory name="qryThisDir" 
           action="LIST" 
        directory="#attributes.rootDir#">

<cfoutput>
<!--- For each entry in files array: --->
<cfloop query="qryThisDir">
  <!--- Select based on entry type: --->
  <cfswitch expression="#type#">
    <cfcase value="File">
      <cffile action="read" 
            variable="strRawInput" 
                file="#attributes.rootDir#\#qryThisDir.Name#">
      <cfset lineCounter = 1>
      <!--- For each line in file input: --->
      <cfloop list="#strRawInput#" delimiters="#crlf#" index="thisLine">
        <cfset hitCol = FindNoCase(attributes.targetString,thisLine)>
        <cfif hitCol GT 0>
              - #qryThisDir.Name# Line #NumberFormat(lineCounter,"000")# Col #NumberFormat(HitCol,"000")#: #HTMLEditFormat(thisLine)#<br>
        </cfif>
        <cfset lineCounter = lineCounter + 1>
      </cfloop>
      <cfif lineCounter GT 1><hr></cfif>
    </cfcase>
    <!--- If it is a directory: --->
    <cfcase value="Dir">
      <!--- Only allow recursion DOWN the directory tree --->
      <cfif NOT (qryThisDir.Name IS "." OR qryThisDir.Name IS "..")>
      <!--- Call strep w/entry --->
      <cf_strep rootDir="#attributes.rootdir#\#qryThisDir.Name#"
           targetString="#targetString#"
                recurse="Yes">
      </cfif>
    </cfcase>
  </cfswitch>
</cfloop>
</cfoutput>
</body>
